/******************* dataDisplay.h **********************/
/*                                                      */
/*                 VIRGO DATA DISPLAY                   */
/*                                                      */
/*   MODULE     : dataDisplay.h                         */
/*   AUTHOR     : D. Verkindt, D. Buskulic (LAPP,Annecy)*/
/*                verkindt@lapp.in2p3.fr                */
/*                                                      */
/******************* dataDisplay.h **********************/

#define DYVERSION  "v9r12p19"
#define DYFDVERSION  "v5r0"

#if !defined(DATA_DISPLAYH)
#define DATA_DISPLAYH DONE

#ifdef __cplusplus
extern "C" {
#endif

#include "dysoundcard.h"
#ifndef NOCM
#include <CmVersion.h>
#include <CmMessage.h>
#endif

#include <UJobL.h>
/*
#include <URPlot.h>
*/
#include <forms.h>
#include <dumpdata.h>
#include <mainbrowser.h>
#include <plot1d.h>
#include <plotraw.h>
#include <plottime.h>
#include <plotfft.h>
#include <plotffttime.h>
#include <plot1dtime.h>
#include <plotrawtime.h>
#include <plottrfct.h>
#include <plot2d.h>
#include <plotaudio.h>
#include <plotgenepar.h>
#include <inputfile.h>
#include <mainpanel.h>
#include <getdd.h>
#include <getshm.h>
#include <cmservers.h>
#include <userfuncbrowser.h>
#include <dydebug.h>
#include <dyoptions.h>
#include <dyoutput.h>
#include <reffile.h>

extern time_t UJtimeStart;


/*======================== Defines and Enums ============================*/

extern char FrVersion[];

#ifdef OSF1
#define __FUNCTION__ "not defined under OSF1"
#endif

#define CURRENT_MANAGER "D. Verkindt (verkindt@lapp.in2p3.fr)"
#define SHM_NFRAMEMAX    8192

#define LSTRING_MAX      1024             /*  max length of character strings                */
#define LBIGSTRING_MAX   2048             /*  max length of big character strings            */
#define NFILE_MAX       65536             /*  max number of files read in a directory        */
#define NPLOT_MAX         64              /*  max number of plots                            */
#define CARFILE          "dd"             /*  default configuration name                     */
#define ROOT_SUFFIX      ".root"          /*  name suffix for plot files                     */
#define CONFIG_SUFFIX    ".car"           /*  name suffix for configuration files            */
#define REF_SUFFIX       "__REF"          /*  name suffix for reference plots                */
#define SEPTITLE         "__"             /*  separator for plot type in plot title          */
#define SEPSMS           "_"              /*  new separator for vVar in case of sms variable */
#define SEP              ".."             /*  separator for vVar in case of sms variable     */
#define SEP2VAR          ".vs."           /*  separator for title of plot with 2 var.        */
#define SEP2VARTR        ".over."         /*  separator for title of plot TrFct              */
#define DYEMPTY          "..."            /*  equivalent to empty string                     */
#define DDREFPLOTS       "ddref.root"     /*  default name of reference plots file           */

#define AUDIOPLAY_OSF1     "/usr/bin/mme/audioplay "
#define AUDIOCONTROL_OSF1  "/usr/bin/mme/audiocontrol "
#define AUDIOPLAY          "/usr/bin/play "
#define AUDIOCONTROL       "/usr/bin/aumix "
#define AUDIOCH_NAME       "fraudio"

#define DY_BADDATA    2.00e+31
#define DY_NOFRAME    1.23e+32
#define DY_NOCHANNEL  3.14e+32
     
#define DYMSG_BADDATA    "CORRUPTED DATA"
#define DYMSG_NOFRAME    "MISSING FRAME"
#define DYMSG_NOCHANNEL  "MISSING CHANNEL"

#define XREF -50
#define YREF -80

/*  Menu items  */

#define CASCINA           "Cascina"
#define FFLDIR            "/virgoData/ffl"

#define READ_FFL          "Read FFL"
#define READ_FILE         "Read Files"
#define CONNECT_CMSERVER  "Connect Online"
#define CONNECT_DD        "Connect to DataSender"
#define READ_SHM          "Connect to Shared Memory"

#define READ_DIRECTORY    "Read Directory"
#define READ_FILE_ONLINE  "Read Files Online"
#define READ_WAVE         "Read Wave File"
#define DECLARE_CM        "Use fixed CmName"
#define CHECK_FILES       "Check Files List"

#define LOAD_CONFIG       "Load Config"
#define SAVE_CONFIG       "Save Config"
#define SAVE_CONFIG_AS    "Save Config As..."
#define DDISPLAY          "ddisplay"
#define DYLOG             "/virgoLog/Dy"
#define DYDUMP_FILE       "dydump.txt"

#define OPSIGNAL          "**"
#define OPSEP             ","
#define OPPAR             "par["
#define SET_PARAMETERS    "Set Parameters"
#define OPERATION_STRING  "Operation String"
#define VALUEIN           "valueIn"
#define USEROP            "UserOp"
#define TRIGGER           "trigger"
#define DYALGO_DIR        "/virgoData/DyAlgo"
#define ALGO_BEGIN        "/*ALGO_BEGIN"
#define ALGO_END          "ALGO_END*/"

#define ADDVECT           "AddVect"
#define SUBVECT           "SubVect"
#define MULTVECT          "MultVect"
#define DIVVECT           "DivVect"
#define INTEGRATOR        "Integrator"
#define LOWPASS           "LowPassFilter"
#define HIGHPASS          "HighPassFilter"

#define TRIGCH            "Trigger from Channels"
#define TRIGASCII         "Trigger from ASCII file"
#define TRIGEVENTS        "Trigger from FrEvents"

#define DDSERVER          "dataSender"
#define DDFFLDIR          "ddffldir"
#define DDCHLIST          "ddchlist"
#define DDFILELIST        "ddfilelist"
#define DATAREQUEST       "DataRequest"
#define DDFILE            "/virgoData/ffl"
#define DDDIR             "/virgoData/ffl"
#define DDWAIT            "ddwait"
#define DYOUTPUTDIR       "./dyoutput"
#define DYOUTPUTFFL       "dyoutput.ffl"

#define CHANNELS_LIST     "ChannelsList"
#define CMTYPE_FDFRAME         "FdFrame"
#define CMTYPE_DYINFO          "dyinfo"
#define CMTYPE_FDFRAMECHANNELS "FdFrameChannels"  
#define CMTYPE_FDADDFRAME      "FdAddFrame"
#define CMTYPE_FDREMOVEFRAME   "FdRemoveFrame"
#define DY_TIMEOUT1       120
#define DY_TIMEOUT2        10 
#define DY_TIMEOUT3         5 
#define ADD_DATA            1             /*  for DyAddDataToDump (add case)           */
#define REMOVE_DATA        -1             /*  for DyAddDataToDump (remove case)        */

#define DY_FONT_TIMES      22
#define DY_FONT_HELVETICA  62

#define NARG_MAX           64
#define NEVENT_MAX     256000             /*  max number of events taken from an ASCII file */
#define DBGTIME_LEVELMAX    6             /*  max number of levels used in DyDebugTimeNeeded */

#define DTMAX               0.
#define FRTIME_MAX       0.98             /*  max time to plot one frame online (sec)  */
#define DURATION_MAX 31536000             /*  max duration of frames reading (sec)     */
                                          /*  86400s x 365days = 31536000 seconds      */
                                          /*  20kHz x 86400s = 1.728e+9 tics = 1 day   */
                                          /*  64bits: LONG_MAX = 9223372036854775807   */
                                          /*  32bits: LONG_MAX = 2147483647 = 3 days at 20kHz */


enum {NEXT_EVENT, NEXT_FRAME, NEXT_UPDATE, CONTINUE, STOP, CLOSE, PAUSE, PAUSE2, WAIT};
                                          /*  data display states (Dy->Order variable)  */

enum {OFF, ON, ON2, ON3};                 /*  some states used by Dy->Clone variable    */

enum {INFILE, INONLINE, INCM, INDD, INVEGA, INSHM, INDIR, INOFF, INWAVE};  /* type of input */

enum {MAINPANEL, HELPPANEL, MAINBROWSER, INPUTFILE, CMSERVERS,
      GETDD, DUMPDATA, PLOTTIME, PLOTCORR, PLOTFFT,
      PLOTTR, PLOTCOHE, PLOT1D, PLOT2D, PLOTAUDIO,
      PLOTFFTTIME, GENEPAR, USERFUNCBROWSER, USERFCTHELP, COFFEEPANEL,
      PLOTRAW, PLOT1DTIME, PLOTRAWTIME, PLOTTRTIME, PLOTCOHETIME,
      PLOT3D, OUTPUTDATA, REFFILE, DYOPTIONS, DYDEBUG, GETSHM};  /*  Panels (and plots) types    */

enum {REPLACE_PLOT,ADD_PLOT};             /*  States for the DySetPlot and DyEditPlotCallBack */

enum {NONE, CONT, LEGO, SURF, SCAT, COL}; /*  options for 2D plots  */

enum {DBG_VDYPLOT, DBG_URPLOT, DBG_PLOT, DBG_FILE, DBG_CM,
      DBG_FRAME, DBG_CHANNEL, DBG_CONFIG, DBG_SPEED, DBG_OTHERS, DBG_CALLS};  /* debug types */

enum {TRIG_CH, TRIG_ASCII, TRIG_EVENTS};  /* type of trigger source */


/*********     WAV BigEndian File Version ***********************/

struct soundhdr {
  char  riff[4];        /* "RIFF"                                  */
  long  flength;        /* file length in bytes                    */
  char  wave[4];        /* "WAVE"                                  */
  char  fmt[4];         /* "fmt "                                  */
  long  block_size;     /* in bytes (generally 16)                 */
  short format_tag;     /* 1=PCM, 257=Mu-Law, 258=A-Law, 259=ADPCM */
  short num_chans;      /* 1=mono, 2=stereo                        */
  long  srate;          /* Sampling rate in samples per second     */
  long  bytes_per_sec;  /* bytes per second                        */
  short bytes_per_samp; /* 2=16-bit mono, 4=16-bit stereo          */
  short bits_per_samp;  /* Number of bits per sample               */
  char  data[4];        /* "data"                                  */
  long  dlength;        /* data length in bytes (filelength - 44)  */
};

/*========================  DyPlot  ============================*/

struct DyPlot {
  long   type;               /* type of the plot (time, fft, 1d, ...)          */
  char   name[LSTRING_MAX];  /* name of the plot                               */
  char   vVarx[LSTRING_MAX]; /* name of the channel to be plot                 */
  char   vVary[LSTRING_MAX]; /* name of second channel to be plot              */
  char   vVarz[LSTRING_MAX]; /* name of third channel to be plot (plot 3D)     */
  double timeSize;           /* larger time window size (s) for plotFFTTime    */
  double tsize;              /* time window size (s)                           */
  double sampFreq;           /* sampling Freq. chosen for this channel (Hz)    */
  double tstep;              /* refresh Period of the plot (% of time window)  */
  double dfreq;              /* frequency resolution (Hz) of FFTTime plots     */
  double dtime;              /* time resolution (sec) of FFTTime plots         */
  long   xnBin;              /* number of bins used                            */
  double xMin;               /* lower edge of the plot                         */
  double xMax;               /* upper edge of the plot                         */
  long   ynBin;              /* number of bins used (2D plots)                 */
  double yMin;               /* lower edge of the plot (2D plots)              */
  double yMax;               /* upper edge of the plot (2D plots)              */
  double zMin;               /* lower z limit of the plot (FFTTime plots)      */
  double zMax;               /* upper z limit of the plot (FFTTime plots)      */
  double filterMin;          /* lower edge of filter band (time plots)         */
  double filterMax;          /* upper edge of of filter band (time plots)      */
  double crossCohe_fmin;     /* lower edge of crossCoherence plot y axis       */
  double crossCohe_fmax;     /* upper edge of crossCoherence plot y axis       */
  int    crossCohe;          /* flag: >0 if plot is a crossCoherence (2D)      */
  long   nSampling;          /* nSampling shift between x and y (2D plots)     */
  double refresh_percent;    /* refreshPeriod of plot (% of timeSize)(FFTTime plots)*/
  long   refreshPeriod;      /* period of plot view updates                    */
  long   resampFactor;       /* sampling frequency / resampling frequency      */
  int    minmax_resample;    /* flag: >0 if resampling is done with min/max values */
  int    sound16bits;        /* flag: >0 if audio output is on 16 bits         */
  int    soundonline;        /* flag: >0 if audio output online stream is on   */
  long   average_fft;        /* number of spectra to average (fft plots)       */
  long   refresh_fft;        /* number of spectra to do before to refresh plot */
  long   t0;                 /* begin time for audio (s)                       */
  long   duration;           /* duration for audio (s)                         */
  long   nBinP2;             /* power of 2 of number of bins used              */
  long   nBin;               /* number of bins used (FFT or 1d-time plot)      */
  int    rmsfft;             /* flag: >0 if rms superposed to spectra          */
  int    decayfft;           /* flag: >0 if average computed with a decay      */
  int    hertz;              /* flag: >0 if no spectra in 1/Hz                 */
  int    x2av;               /* flag: >0 if average uses square of values      */
  int    nodc;               /* flag: >0 if no DC component in spectra         */
  int    bits;               /* flag: >0 if bits of values are displayed       */
  int    gridx;              /* flag to get x grid                             */
  int    gridy;              /* flag to get y grid                             */
  int    gridz;              /* flag to get z grid                             */
  int    logx;               /* flag to get x log scale                        */
  int    logy;               /* flag to get y log scale                        */
  int    gridx2;             /* flag to get x grid in phase plot               */
  int    gridy2;             /* flag to get y grid in phase plot               */
  int    logx2;              /* flag to get x log scale in phase plot          */
  int    logy2;              /* flag to get y log scale in phase plot          */
  int    logz;               /* flag to get z log scale (2D plots)             */
  int    stat;               /* flag to get statistical info (1D plots)        */
  int    type2d;             /* flag to plot 2D histos as CONT, LEGO or SURF   */
  int    realUnits;          /* flag for Y axis in real Units instead of ADC#  */
  int    autoScale;          /* flag to have Y axis auto scaling in TIME plots */
  int    modulesqrt;         /* flag to have sqrt of module in COHE plots      */
  int    autoEdge;           /* flag to have auto edges updates in 2D/1D plots */
  int    superposed;         /* flag to superimpose plot on the previous one   */
  int    hidden;             /* flag>0 when plot is hidden in the list         */
  double freqClock;          /* frequency of the clock associated to the plot  */
  long clockN;               /* number of the clock associated to the plot     */
  double freqClock2;         /* frequency of the 2nd clock of the plot         */
  long clockN2;              /* number of the 2nd clock associated to the plot */
  double freqClock12;        /* frequency of the clock used in 2 var. plot     */
  long clockN12;             /* number of the clock associated to 2 var. plot  */
  double freqClock3;         /* frequency of the 3nd clock of the plot         */
  long clockN3;              /* number of the 3nd clock associated to the plot */
  double yoffset;            /* users's offset on Y axis of TIME plots         */
  double yscale;             /* users's scaling factor on Y axis of TIME plots */
};

/*========================  DyTool  ============================*/

struct DyTool {
  int   debug;                    /* debug level (if <0, no GPS origin line under plots)  */
  int   debugType;                /* debug type (which part of code is debugged)          */
  long   notoc;                   /* >0 if TOC is not used when reading frames in files   */
  struct FrameH *Frame;           /* a frame first read to get the channels               */ 
  double Framedt;                 /* duration of Frame. Used as threshold on AnaTime      */
  long   nAnaTime;                /* number of frame to use to compute AnaTime            */
  double AnaTime;                 /* mean time needed to analyse frames                   */
  double oldTime;                 /* time of previous pass in UFrIFileCmSim               */
  long   nTics;                   /* number of siesta clock tics between tBegin and tEnd  */
  char   clockString[LBIGSTRING_MAX];           /* the clocks String of the config file   */
  char   triggerString[LBIGSTRING_MAX];         /* the trigger String of the config file  */
  char   *fileString;                           /* the files String of the config file    */
  char   plotString[NPLOT_MAX][LBIGSTRING_MAX]; /* plots Strings of the config file       */
  char   StartEndString[LSTRING_MAX];           /* string containing first, start, end fr# */
  char   RowColString[LSTRING_MAX];             /* string containing nCol and nRow of plots */
  long   waitMax;                 /* timeout value for CmMessageWait                      */
  char   curConfig[LSTRING_MAX];  /* generic current name used for .car .hsto files       */
  long   CmConnect;               /* flag to know if we are Cm connected or not           */
  char   fileName[LSTRING_MAX];   /* read file name                                       */
  char   shmName[LSTRING_MAX];    /* shared memory producer name                          */
  int    nshm;
  char   shmlist[32][32];
  char   CmName[LSTRING_MAX];     /* Cm name of the datadisplay                           */
  char   CmServer[LSTRING_MAX];   /* Cm name of server to which dataDisplay is connected  */
  char   CmDomain[LSTRING_MAX];   /* Cm Domain used each time DyCmConnect is used         */
  int    plotsNotDisplayed;       /* flag>0 if plots computed but not displayed           */
  int    QuitAtStop;              /* flag>0 if dataDisplay quits when it stops            */
  int    BgRun;                   /* flag>0 if ROOT plots are done in background and saved as jpg */
  char   *outPicture;             /* Name of output picture (with suffix .jpg or root.    */
  char   *titleCmd;               /* title of the canvas taken from command line          */
  int    colorpalette;            /* colorpalette type: 0=rainbow 1=flame 2=green 3=violet */
  char   chPrefix[32];            /* Channel prefix (H1, V1, etc...) used in the data read */

  char   conditionName[LSTRING_MAX];/* FrEvent names                                      */
  double conditionTh;               /* FrEvents threshold                                 */
  struct FrVect *triggerVect;     /* vector containing 1 if sampling triggers, 0 otherwise */
  int    triggerPause;            /* flag is positive if option of pause on trigger chosen*/
  int    triggerUsed;             /* flag is positive if dataDisplay runs with a trigger  */
  int    triggerEvent;            /* flag is positive if a trigger has seen an event      */
  int    triggerType;             /* type of trigger source: 0=channels 1=AsciiFile 2=FrEvents  */
  int    nevent_ascii;            /* number of events in ASCII file                       */
  double AsciiGps[NEVENT_MAX];    /* list of gps times of the events taken from ASCII file */
  char   trigAsciiFileName[LSTRING_MAX]; /* Name of ASCII file containing trigger GPS times */
  char   trigEventName[LSTRING_MAX];     /* Name of EVENT used to search for trigger GPS times */
  char   lastTrigString[LBIGSTRING_MAX]; /* last trigger string used                       */
  char   *trigMenuItem;           /* last item chosen in Trigger menu                     */

  char   lastOpString[LBIGSTRING_MAX];/* last operation string used                       */
  char   savedPlots[LSTRING_MAX]; /* last file name used to save plots                    */
  char   *refplot_dir;            /* last directory where reference plots file was read  */
  char   *refPlots;               /* last file name used to save reference plots          */
  char   *reflist;                /* list of reference plots file to be  used             */
  char   savedConfig[LSTRING_MAX];/* last file name used to save config ie siesta cards   */
  char   *config_dir;             /* last directory where configuration file was read     */
  int    refplot_color;           /* color of the reference plots to be superposed        */
  int    refplot_indelebile;      /* flag>0 if superposed reference plots are indelebile  */
  int    nicefont;                /* flag>0 if font 62 (instead of 20) is used while running  */
  char   *Dir;                    /* directory were are the frames files to read          */
  char   typeName[NARG_MAX][64];  /* explicit type name of a plot                         */
  char   *smsName;                /* name of the SMS                                      */
  char   *smsvarName;             /* name of the SMS variable                             */
  char   *adcName;                /* name of the adc channel                              */
  char   *procName;               /* name of the proc channel                             */
  char   *simName;                /* name of the sim channel                              */
  FILE   *dumpfp;                 /* file where is saved the dump of data                 */
  long   lastSearchI;             /* last line found in browser by the searchInBrowser    */
  char lastSearchName[LSTRING_MAX]; /* last name found by the searchInBrowser             */
  long    firstTime;              /* GPS time of first frame read                         */
  int    startRun;                /* run number of first frame to plot                    */
  int    startFrame;              /* frame number of first frame to plot                  */
  long   startTime;               /* starting GPS time                                    */
  long   startTimeCmd;            /* starting GPS time provided on command line           */
  double currentTime;             /* current GPS time of data read                        */
  double previousTime;            /* previous current GPS time of data read               */
  long   duration;                /* time duration over which we look data                */
  long   durationCmd;             /* time duration provided on command line               */
  long   timeOrigin;              /* starting time unchanged, used in URPlot.c            */
  long   y2d;                     /* flag for 2D plots management                         */
  long   Order;                   /* data taking status of the data display               */
  long   Clone;                   /* flag to say that all plots of same type are updated  */
  char   *AutoConf;               /* config name when dataDisplay get config from args    */
  int    AutoConfFlag;            /* flag is positive if dataDisplay started with a config*/
  long   InputType;               /* flag to keep input type                              */
  long   filelist_flag;           /* flag >0 if dataSender sent a file list               */
  int    DdNS;                    /* flag >0 if getting dataSenders lsit from Cm NS       */
  char   Ddffldir[LSTRING_MAX];   /* default ffl directory provided by dataSender         */
  char   *Ddchlist;               /* channels list string from Data distribution server   */
  char   *Ddpasswd;               /* password for Data distribution server access         */
  char   DdDir[LSTRING_MAX];      /* Directory scanned by Data distribution server        */
  char   DdServer[LSTRING_MAX];       /* Cm name of the Data distribution server          */
  char   Ddinputfile[LBIGSTRING_MAX]; /* input file to be read by dataSender              */
  double freqClock[2*NPLOT_MAX];  /* frequencies used by the plots                        */
  long   nClock;                  /* number of frequencies used by the plots              */
  int start_latency;
  void*  frameChannel;            /* pointer to frame channel when used with vega         */
  double corrupt;
  char previoustrigVectList[LBIGSTRING_MAX]; /* used in DySetTriggerString to keep mem. of trig userop  */
  char previousVectList[LBIGSTRING_MAX]; /* used in DySetOpString to keep mem. of userop  */
  char   *userMenuItem;           /* last item chosen in User Fonctions menu              */
  int    AutoDeselectPlot;        /* flag to automatically deselect plots browser entries */
  int    AutoDeselectCh;          /* flag to automatically deselect channels browsers entries */
  int    skipFrame;               /* flag to skip missing frames or not                   */
  int    nCol;                    /* user chosen number of columns in Root Canvas         */
  int    nRow;                    /* user chosen number of raws in Root Canvas            */
  int    squarePlot;              /* is 1 when plots should be squares                    */
  char   *cmacrocopy;             /* string that contains Root Canvas taken from config   */
  int    timeDisconnect;          /* time of last Cm disconnection                        */
  int    unpacki;
  int nplot;                      /* number of plots (except audio and hidden plots)      */
  int nplotdrawn;                 /* number of plots drawn in the pads                    */
  int nready;
  int nsame;
  int plotReady[256];
  int refnumplot[256];
  int noBox;     /* is 1 if green boxes not displayed when channels missing */
  char output_dir[LSTRING_MAX];
  int output_flag;
  int output_nframe_perfile;
  char output_tag[LBIGSTRING_MAX];
  int output_nframe_written;
  double output_nbytes_tot;
  struct FrFile *output_ffl;
  struct FrFile *output_file;
  char gLastTitle[1024];
  char gLastTitleY[1024];
};


#ifdef USE_VEGA
/*========================  DyExtern  ============================*/

struct DyExtern {
  void*   dyFrameChannel;            /* used to transfer any data from outside */
  void    (*externIni)();            /* external init function                 */
  FrameH* (*externReadFirstFrame)(); /* external read first frame function     */
};

int DyMain(struct DyExtern* dySource);  /* main routine in the scope of the vega viewer       */
extern struct DyExtern* DyExternSource; /* global variable for interaction with outside world */
#endif


/***********/
/*  HELPS  */
/***********/

void DyXformHelpPanel (FL_OBJECT *obj, long arg);
void DyXformCoffeePanel (FL_OBJECT *obj, long arg);
void DyXformSurprisePanel (FL_OBJECT *obj, long arg);
void DyHelpMainPanel (FL_OBJECT *ob, long arg);
void DyHelpMainBrowser (FL_OBJECT *ob, long arg);
void DyHelpDumpData (FL_OBJECT *ob, long arg);
void DyHelpPlottime (FL_OBJECT *ob, long arg);
void DyHelpPlotfft (FL_OBJECT *ob, long arg);
void DyHelpPlotffttime (FL_OBJECT *ob, long arg);
void DyHelpPlot1dtime (FL_OBJECT *ob, long arg);
void DyHelpPlotrawtime (FL_OBJECT *ob, long arg);
void DyHelpPlottrfct (FL_OBJECT *ob, long arg);
void DyHelpPlot1d (FL_OBJECT *ob, long arg);
void DyHelpPlot2d (FL_OBJECT *ob, long arg);
void DyHelpAudio (FL_OBJECT *ob, long arg);
void DyHelpPlotGenePar (FL_OBJECT *ob, long arg);
void DyHelpCmConnect (FL_OBJECT *ob, long arg);
void DyHelpOptions (FL_OBJECT *ob, long arg);
void DyHelpOutput (FL_OBJECT *ob, long arg);
void DyHelpDebug (FL_OBJECT *ob, long arg);
void DyHelpReffile (FL_OBJECT *ob, long arg);
void DyHelpUserFct (FL_OBJECT *ob, long arg);
void DyUserProcHelp (FL_OBJECT *ob, long arg);
int  DyHelp (FL_OBJECT *ob, int, FL_Coord, FL_Coord, int, void *);

/********************/
/*  INIT and RESET  */
/********************/

void DyXformIni (char **arg1,int *arg2);
void DyIni (char **arg1, int arg2);
void DyXformRaz (FL_OBJECT *ob, long arg);
void DyRaz (long arg, long nplot);
void DyMakeTypeNames();
int  DyQuitAtClose(FL_FORM *flForm, void *data);
void DyConstrain (double *value);
char *DyCheckString (char* name);
char *DyFilterString (char* namei, unsigned char separator);
void DyXformSetDebug (FL_OBJECT *ob, long arg);

/***************/
/*   RUNNING   */
/***************/

void DyFirstLast (double framePeriod);
void DyXformFirstLast (long *start, long *duration, int *startFrame, int *startRun);
void DyStart (long nPlot);
void DyXformStart (FL_OBJECT *obj, long arg);
void DyXformSetNoToc (FL_OBJECT *obj, long arg);
void DyPause ();
void DyXformPause (FL_OBJECT *obj, long arg);
void DyStop ();
void DyXformStop (FL_OBJECT *obj, long arg);
void DyNext (long arg);
void DyXformNext (FL_OBJECT *obj, long arg);
void DyContinue ();
void DyXformContinue (FL_OBJECT *obj, long arg);
void DySiestaLike (char *carfile);
void DyInteractionSim (void *iFile, long time);
int  DyCheckRunning();
int  DyAtClose(FL_FORM *flForm, void *data);
int  DyGTimeFromDate (char *inputDate);
int  DyJulianDay(int y, int m, int d);
int  DyMissingFrames (int previous, struct FrameH *frame);
long DyGrafIni (long reset);
void DySoundReadHeader (char *buffer);
void DySoundFillHeader(struct soundhdr *hdr, long srate, long nBytes, short bits_per_sample);
int DySerDataGet(FrameH *frame, char *name, char **sername, char **param, double *result);
double DyTimeFormatToGps (const char *timeformat);
char *DyGpsToTimeString (double origin, struct FrameH *frame, double deltat, int nAverage, char *title);
time_t DyConvertToUTC (int gps, int uLeapS);
double DyGetStartTime();
double DyDebugTime();
char *DyDebugTimeStr (char *name, int printflag);
double DyDebugTimeNeeded (const char *fctname, const char *flag, int level);
void DyDebugPrint (const char *msg, int printflag);

/*******************/
/*   Shm CONNECT   */
/*******************/

struct ShmInfo
{
  key_t key;                  /* key to sign the shared memory segment */
  int  shmid;                 /* id of the shared memory segment (deduced from the key) */
  void *segptr;               /*address shared memory segment */
  long size;                  /* size of the shared memory segment (bytes) */
  char version[64];           /* version of FdShm */
  long dynamic;               /* flag>0 if optimize shm for variable size frames */
  long statusSize;            /* size of shminfo structure */
  long frameSizeMax;          /* maximum size of a frame in shm */
  long nFrameMax;             /* maximum number of frames in shm (if dynamic=0) */
  int latency;                /* max latency of the producer */

  long frameSh[SHM_NFRAMEMAX];    /* address of frames in shm */
  long frameSize[SHM_NFRAMEMAX];  /* size of frames in shm (bytes) */
  int  frameGPS[SHM_NFRAMEMAX];   /* GPS time of frames in shm */
  long iwrite;                /* write counter of the shm producer */

  long nConsumer;              /* number of consumers connected to shm */
  int  producerPid;            /* producer pid */
  char producerName[128];      /* producer Cm name */
  char outputName[128];        /* name of the common output of the consumers (triggermanager) */

  long iwriteMod;             /* write counter modulo number of frames in shm */
  long iwriteMax;             /* iwrite of the last frame in shm */
  long curSizeMax;            /* size of the current largest frame in shm */
};


/*******************/
/*  SHARED MEMORY  */
/*******************/

void   FdShmInfoFree (struct ShmInfo *shm);
long   FdShmGetIwrite (struct ShmInfo *shm);
long   FdShmGetnFrameMax (struct ShmInfo *shm);
void   FdShmFree (struct ShmInfo *shm, char *name);
void   FdShmSetDynamic (struct ShmInfo *shm, long dynamic);
void   FdShmClose (struct ShmInfo *shm, char *name);
struct ShmInfo *FdShmOpen (char *idName, char *name);
int    FdShmMakeKey (char *name);
long   FdShmCsmIni (struct ShmInfo *temp, long *shmiread);
struct FrameH *FdShmRead (struct ShmInfo *shm, long *shmiread, long compress, int *nBytes);
struct FrameH *FdShmReadDynamic (struct ShmInfo *shm, long *shmiread, long compress, int *nBytes);

int  DyGetShmList();
void DyAddShm(char *shmname);
void DyXformAddShm (FL_OBJECT *obj, long arg);
void DyUpdateShmList();
void DyXformUpdateShmList(FL_OBJECT *obj, long arg);


/******************/
/*   Cm CONNECT   */
/******************/

#ifndef NOCM
CmMessageStatus UFrHandlerCm(CmMessage message,char* sender,char* serverName);
CmConnectCondition DyCmWait (int timeout, char *servername);
#endif
int DyCmConnect (char *CmName);
void DyCmDisconnect (char *CmName);
void DyUpdateCmList();
void DyCmSetCmDomain (char *DyCmDomain);
void DyXformCmName (FL_OBJECT *obj, long arg);
void DyXformCmConnect (FL_OBJECT *obj, long arg);
void DyXformUpdateCmList (FL_OBJECT *obj, long arg);
#ifndef NOCM
CmMessageStatus DyNamesHandler (CmMessage message, char* sender, char* serverName);
CmMessageStatus DyInfoHandler (CmMessage message, char* sender, char* serverName);
int DyFdGetData (CmMessage message, char **name, 
               int *run, int *fnum, 
               int *gtimeS, int *gtimeN, 
               int *trig, int *nBytes, char **buf);
struct FrameH *DyFdGetFrameWithSize (CmMessage message, int compress, int *nBytes);
#endif
int DyFdOutSendAdd (char* dest, char* serverName, char *tagAdc, char *tagSer,
                  int maxTry, int priority);
int DyFdOutSendRemove (char* dest, char* serverName);
int DyFdSendFrameChannelsRequest (char *dest);


/******************/
/*   DD CONNECT   */
/******************/

#ifndef NOCM
CmMessageStatus DyDdHandlerFFL (CmMessage message, char* sender, char* servername);
CmMessageStatus DyDdHandlerChlist (CmMessage message, char* sender, char* servername);
CmMessageStatus DyDdHandlerFilelist (CmMessage message, char* sender, char* servername);
#endif
long DyDdFFLRequest (char *DdServer);
long DyDdChlistRequest (char *DdServer, char *inputfile, int gpsStart);
void DyDdPauseRequest (char *DdServer);
void DyDdContinueRequest (char *DdServer);
long DyDdDataRequest (char *DdServer, char *inputfile, char *tag, int gpsStart, int nSeconds);
long DyDdSendWaitingTime (double waiting_time);
void DyXformDdGetChlist (FL_OBJECT *obj,long arg);
void DyXformDdGetFile (FL_OBJECT *obj, long arg);


/*************/
/*   FILES   */
/*************/

void DyReadingFrames();
void DyGetfirstFrame (long arg);
struct FrameH *DyWaveToFrame (char *wavefilename, double framedt);
int  DyReadFirstFrame (char *chosen_file, long arg);
double DyGetFramedt(struct FrameH *frame);
void DyAddDir (char *directory, char *file, long arg);
void DyXformAddDir (FL_OBJECT *obj, long arg);
void DyXformAddFile (FL_OBJECT *obj, long arg);
void DyXformRemoveFile (FL_OBJECT *obj, long arg);
void DyXformAddShm (FL_OBJECT *obj, long arg);
char *DyGetDir (char *dirname, char *allname);
char *DyBaseName (char *allname);
long DySortFiles (char *dirName, char **fileName);
long is_a_file (char *arg);
long is_a_dir (char *arg);

void DyXformSetMaxDuration (FL_OBJECT *obj, long arg);
void DyXformOutputDefault (FL_OBJECT *obj, long arg);
void DyXformPanelToOutput (FL_OBJECT *obj, long arg);
void DyXformOutputToPanel();
void DyOutputDefault();
void DyOutputWrite (struct FrameH *frame);
void DyOutputClose();
struct FrameH *DyOutputReadCache (int gtime, char *tag);


/****************/
/*   VARIABLE   */
/****************/

void DyChangeVarName (char *result, char *vVar, int datatype, int datatype_new, double freqClock);
void DyUpdateDataType (struct FrameH *frame);
void DyXformUpdateChList (FL_OBJECT *fl, long arg);
struct FrameH *DyChListToFrame (struct FrameH *frame);
struct FrameH *DyCharChListToFrame (char *chList);
int DyGetFrameHFromChList (char *chList, int *uleaps, double *frameDt, int *frameN, int *runN);
const char *DyGetFromChList (char *chList, char *chName,
                             double *freq, char **smsData, double *valMin, double *valMax);
const char *DyGetTypeFromChList (char *chList, char *chName);
void DyXformDeSelect (FL_OBJECT *obj, long arg);
void DyDecodePlotName (char *inputString, char **varx, char **vary);
void DyDecodeVar (char *input, char **smsName, char **varName,
                  char **adcName, char **procName, char **simName);
void DyXformSetVar (FL_OBJECT *obj, long arg);
int DyGetSmsVarList (int *ifirst, char **wordlist, struct FrSerData *smsStation);
void DyXformFillMainBrowser (struct FrameH *frame);
void DyXformSortBrowser (FL_OBJECT *browser);
void DyXformGetstartTime (FL_OBJECT *obj, long arg);
void DyXformFilterBrowser (FL_OBJECT *obj, long arg);
void DyXformGetPrefix (FL_OBJECT *browser);
void DyXformFindInBrowser (FL_OBJECT *obj, long arg);


/*************/
/*   PLOTS   */
/*************/

void DyXformScanPlots (FL_OBJECT *obj, long arg);
void DyPlotFrames();
void DyXformSetOnePlot (FL_OBJECT *obj, long i);
void DySetPlot (FL_OBJECT *obj, long arg);
void DyXformSetOnePlotVarY (FL_OBJECT *obj, long arg);
void DyXformEditPlot (FL_OBJECT *obj, long arg);
void DyXformGetPlotPanel (FL_OBJECT *, long);
void DyXformRemovePlot (FL_OBJECT *, long);
int  DySavePlot (char *savedPlots);
void DyXformSavePlot (FL_OBJECT *obj, long arg);
void DyXformSetRefPlot (FL_OBJECT *obj, long arg);
void DyXformGetRefPlot (FL_OBJECT *obj, long arg);
void DyXformAddToRefList (char *filename, int color);
void DyXformRemoveRefFile (FL_OBJECT *obj, long arg);
void DyXformRemove2DRefFile (FL_OBJECT *obj, long arg);
void DyXformEditRefFile (FL_OBJECT *obj, long arg);
void DyXformClonePlot (FL_OBJECT *obj, long arg);
void DyCopyPlot (long idout,long idin);
void DyCopyPlotForSame (struct DyPlot *target, struct DyPlot *source);
void DyXformUpdatePlotBrowser (long id, long add_or_remove);
void DyXformHideShowPlot(FL_OBJECT *obj, long arg);

void DyXformPutDefaultInAllPlots (FL_OBJECT *obj, long arg);
void DyXformGetGeneParPanel (FL_OBJECT *obj, long arg);
void DyXformGeneParToPlot (FL_OBJECT *obj, long arg);

long DyXformPanelToPlot (long id);
void DyXformPlotToPanel (long id);
void DyXformPutDefaultInPanel (FL_OBJECT *obj, long arg);
void DyUpdatePlotName (int id);
void DyUpdatePlotParam (struct FrameH *frame, int id);
void DyPutDefaultInPlot (long id);
void DyGetDefaultFromPlot (long id);
void DyPlotInit (long id, long flag);
void DyXformSamePlot (FL_OBJECT *obj, long arg);
void DyXformUnsamePlot (FL_OBJECT *obj, long arg);
void DyXformExchangeVar (FL_OBJECT *obj, long arg);
void DyXformPlotUp (FL_OBJECT *obj, long arg);
void DyXformPlotDown (FL_OBJECT *obj, long arg);
void DyXformTransformPlot (FL_OBJECT *obj, long arg);


/**************/
/*   PANELS   */
/**************/

void DyXformCleanPanel (FL_OBJECT *obj, long arg);
void DyXformRaisePanel (FL_OBJECT *obj, long arg);
void DyXformClosePanel (FL_OBJECT *obj, long arg);
void DyXformMenu (FL_OBJECT *obj, long arg);


/***************/
/*   CONFIGS   */
/***************/

void DyXformSaveConfig (FL_OBJECT *obj, long arg);
void DyXformGetConfigFile (FL_OBJECT *obj, long arg);
char *DyReadConfigFile (char *config_filename);
void DyGetConfig (char *config);
int DyGetStartEndFromConfig (char **wordlist, long *i, long nword);
int DyGetRowColFromConfig (char **wordlist, long *i, long nword);
void DyGetVectOpFromConfig (char **wordlist, long *i);
long DyGetClocksFromConfig (char **wordlist, long *i, long nword);
long DyGetFilesFromConfig (char **wordlist, long *i, long nword, long arg);
long DyGetPlotFromConfig (char **wordlist, long *i, long nword, long id);
void DyGetPlotOptions (long id, char **wordlist, long *i, long nword);

/*******************/
/*   USER MACROS   */
/*******************/

void DyLoadScript (char *className);
void DyXformMakeNewMacro (FL_OBJECT *obj, long arg);
void DyXformLoadInterpretMacro (FL_OBJECT *obj, long arg);
void DyXformLoadCompileMacro (FL_OBJECT *obj, long arg);
void DyXformUpdateUserProcBrowser();
void DyXformAddUserChannel (struct FrameH *frame, FL_OBJECT *obj, char *className, char *inputVect);
void DyXformSetOp (FL_OBJECT *obj, long arg);
void DySetOpString(char *userFct);
void DyMakeOpCString ( char *opstring, char *opstring2, char *inputVect);
char *DyOpStringReplaceChannels (char *opstring, char *vectlist);
void DyXformProcRemove (FL_OBJECT *obj, long arg);
void DySetOpPar();
void DyXformRemoveUserProcFiles();
void DyXformSetTrigger (FL_OBJECT *obj, long arg);
void DySetTriggerList();
void DySetTriggerString();
void DyMakeTrigCString ( char *opstring, char *opstring2, char *inputVect);
void DyMakeTrigEventList (char *opstring);

/***************/
/*   STRINGS   */
/***************/

void DyMakeTriggerString();
long DyMakeClockString();
int  DyPPCM( double *freqClock, int nclock, double *fastest);
int  compute_pgcd (int nbr1, int nbr2);
long DyMakeFileString (long arg);
void DyMakeTag (char *tag);
char *DyAddToTag (char *tag, char *name);
void DyMakePlotString (long id);
void DyMakeStartEndString ();
void DyMakeRowColString ();
void DyMakeAlgoString (FILE *fp);
long DyMakeSiestaFile (char *fileName, int noroot);
void DyMakePlotOptions (long id, char *options, char *options2);
void DyWindowsIni (long nwindows);

/************/
/*   DUMP   */
/************/

void DyXformAddDataToDump (FL_OBJECT *obj, long arg);
void DyXformAddToDumpList (FL_OBJECT *obj);
void DyXformRemoveFromDumpList (FL_OBJECT *obj);
void DyXformDumpData (struct FrameH *frame, long not_frame);
void DyDumpOneVar (struct FrameH *frame, char *varName, long level);
void DyXformSaveDump (FL_OBJECT *, long);
void DyFillFrameDump (struct FrameH *frame, int level);
int  DyCheckData (struct FrVect *data);
void DyXformAddInDump (char *str);
char *DyFrVectDumpToBuf (struct FrVect *vect, char *buf, long dumplevel);

/**************/
/*   DIVERS   */
/**************/
void DyColorPalette (FL_OBJECT *obj, long arg);

void DyXformGetButton (FL_OBJECT *obj, long arg);
void DyXformAutoDeselect (FL_OBJECT *obj, long arg);
void DyXformNow (FL_OBJECT *obj, long arg);
void DyAudioControl (FL_OBJECT *obj, long arg);
void DyXformQuit (FL_OBJECT *obj, long arg);
void quitHandler (int arg);
void DyFree();

void DyInfoLine (char *msg);
void DyInfoPanel (char *msg, int alarm);
void DyCurrentInput (char *msg);
void DyXformUpdateCounters (int frameN, int runN, int gtime, int uleaps);
void DyXformUpdateGTime (double gtime, int uleaps);
void DyXformAddToFileList (char *fileName);
void DyXformSortFileList();

char *my_strcpy (char *dummy, char *str);
double DyGetMin (double x1, double x2);
double DyGetMax (double x1, double x2);
void DyGetMinMax (struct FrVect *vect, double *vmin, double *vmax);
void DyGetMinMaxFromTrend (struct FrameH *frame, char *adcName, double *vmin, double *vmax);
void DyXformPadsConfig (FL_OBJECT *obj, long arg);
void DyXformChecks (FL_OBJECT *obj, long arg);
void DyCheckPlot (long id);
int  DyCheckMemory();
int  DyCountChannels(struct FrameH *frame);

void DyVisuClear (long arg);
void DyVisuIni (char *fileName);
void DyVisuEnd();
void DySetRowCol (int ntot, int *nCol, int *nRow);
void DyXformSetScanStep (double step);

extern struct UJstructH *UserUJstructH;
extern struct DyTool* Dy;
extern struct DyPlot* Plot[NPLOT_MAX];
extern struct FrVect *UFrCurVect;
extern struct FrameH *UFrCurFrameH;
extern int UFrCurFrameHSize;
extern struct soundhdr wavehdr; 
extern struct timeval dytv; 
extern double         dyptime;
extern char           dytimestr[256];
extern double ptime[DBGTIME_LEVELMAX+1];
extern char fctnamep[DBGTIME_LEVELMAX+1][256];
 
extern FD_mainbrowser *mainbrowser;
extern FD_inputfile   *inputfile;
extern FD_mainpanel   *mainpanel;
extern FD_userfuncbrowser   *userfuncbrowser;
extern FD_plotaudio   *plotaudio;
extern FD_plotgenepar *plotgenepar;
extern FD_plot1d      *plot1d;
extern FD_plot2d      *plot2d;
extern FD_plotraw     *plotraw;
extern FD_plottime    *plottime;
extern FD_plotfft     *plotfft;
extern FD_plotffttime *plotffttime;
extern FD_plot1dtime  *plot1dtime;
extern FD_plotrawtime *plotrawtime;
extern FD_plottrfct   *plottrfct;
extern FD_dumpdata    *dumpdata;
extern FD_getdd       *getdd;
extern FL_FORM        *helppanel;
extern FL_FORM        *coffeepanel;
extern FL_FORM        *userprochelp;
extern FD_cmservers   *cmservers;
extern FD_getshm      *getshm;
extern FD_dydebug     *dydebug;
extern FD_dyoptions   *dyoptions;
extern FD_dyoutput    *dyoutput;
extern FD_reffile     *reffile;

#ifdef __cplusplus
}
#endif

#endif
