
/**************************************************************
 *
 *      USER CLIENT - BASIC MODULE
 *
 **************************************************************
 *
 *      MODULE     : ClXGoodies
 *      AUTHOR     : L. FOURNIER
 *      LABORATORY : L.A.P.P.
 *      VERSION    : v3r04
 *      DATE       : 9.2.2002
 *
 **************************************************************
 * xforms utility functions
 **************************************************************
 * v3r04 - 9.2.2002 - creation
 * $Id: fselector.h,v 1.1.1.40 2012/10/26 14:41:58 verkindt Exp $
 * - goodies, chapter 6
 * void ClXInfo(const char *fmt, ...);
 * void ClXMessage(const char *fmt, ...);
 * void ClXAlert(const char *fmt, ...);
 * int  ClXQuestion(int def, const char *fmt, ...);
 * int  ClXFSelector(char *title, const char *directory,
 *                   const char *pattern, const char *filename, char *result);
 **************************************************************/

#ifndef CLXGOODIES_H
#define CLXGOODIES_H

#ifdef MPATROL
#include <mpatrol.h>
#endif

#include <forms.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/**************************************************************/
/* info/message/alert/question dialog boxes */
void ClXInfo(const char *fmt, ...);
void ClXMessage(const char *fmt, ...);
void ClXAlert(const char *fmt, ...);
int  ClXQuestion(int def, const char *fmt, ...);

/**************************************************************/
/* file selector dialog box */
int ClXFSelector(char *title,               /* form title */
                 const char *directory,     /* starting directory */
                 const char *pattern,       /* file pattern to search */
                 const char *filename,      /* default filename selected */
                 char *result,              /* result buffer */
                 int size);                 /* result buffer size */
void ClXFSelectorSetFiletypeMarker(int dir, int fifo, int sock, int cdev, int bdev);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
