#ifndef VSTYLEPADHIST_DEFINED
#define VSTYLEPADHIST_DEFINED

/*--- C++ part of the RootAccess header ---*/

#include "TStyle.h"
#include "TObject.h"

/*--- Structure to hold the pads and histogram style/characteristics ---*/
/*--- Used to keep these styles between a stop and a restart         ---*/
   
class VStylePadHist : public TObject {

private:
      double   mYMin;        // minimum in y direction of the plot
      double   mYMax;        // maximum in y direction of the plot
      int      mXRangeMin;   // minimum bin in x
      int      mXRangeMax;   // maximum bin in x
      TStyle*  mStyle;       // style attributes of the pad and histogram
      TPad*    mPad;         // pad pointed by this style
public:
      VStylePadHist();
      VStylePadHist(int xrmin, int xrmax, double ymin, double ymax,
                                            TStyle* style, TPad* pad);
      ~VStylePadHist();
      double   GetYMin() {return mYMin;}
      double   GetYMax() {return mYMax;}
      int      GetXRangeMin() {return mXRangeMin;}
      int      GetXRangeMax() {return mXRangeMax;}
      TStyle*  GetStyle() {return mStyle;}
      TPad*    GetPad() {return mPad;}
      void     SetYRange(double ymin, double ymax) {mYMin=ymin;mYMax=ymax;}
      void     SetXRange(int xrmin, int xrmax) {mXRangeMin=xrmin;mXRangeMax=xrmax;}
      void     CopyStyle(TStyle* style) {mStyle = (TStyle*)style->Clone();}
      void     SetPad(TPad* pad) {mPad=pad;}
}

#endif
