// Original Author: Rene Brun   05/02/97
// Modified for use in VEGA by D. Buskulic 21/03/03

#ifndef VEGA_VViewerSelectorCint
#define VEGA_VViewerSelectorCint


//////////////////////////////////////////////////////////////////////////
//                                                                      //
// VViewerSelectorCint                                                  //
//                                                                      //
// A utility class for Viewer selections.  (via interpreter)            //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#ifndef VEGA_VSelector
#include "VViewerSelector.h"
#endif

#include "Api.h"

// class G__CallFunc;
// class G__ClassInfo;

class VViewerSelectorCint : public VViewerSelector {

private:
   void SetFuncProto(G__CallFunc *cf, G__ClassInfo* cl, const char* fname,
                     const char* argtype);

protected:
   G__CallFunc     *mFuncInit;     //!
   G__CallFunc     *mFuncBegin;    //!
   G__CallFunc     *mFuncTerm;     //!
   G__CallFunc     *mFuncCut;      //!
//   G__CallFunc     *mFuncFrame;    //!
   G__CallFunc     *mFuncVect;     //!
   G__CallFunc     *mFuncOption;   //!
   G__CallFunc     *mFuncObj;      //!
   G__ClassInfo    *mClass;        //!
   VViewerSelector *mIntSelector;  //Pointer to interpreted selector (if interpreted)

public:
   VViewerSelectorCint();
   virtual            ~VViewerSelectorCint();
   virtual void        Build(VViewerSelector *iselector, G__ClassInfo *cl);
   virtual void        Init();
   virtual void        Begin();
   virtual const char* GetViewerClassName();
   virtual Bool_t      ProcessCut(FrameH*);
//   virtual Bool_t      ProcessFrame(FrameH*);
   virtual Bool_t      ProcessVect(int, FrVect**, FrVect*, double*);
   virtual void        SetOption(const char *option);
   virtual void        SetObject(TObject *obj);
   virtual void        Terminate();

   ClassDef(VViewerSelectorCint,0)  //A utility class for processing in the viewer (interpreted version)
};

#endif

