#define HighPassFilter_cxx
// The class definition in HighPassFilter.h has been generated automatically
// by the Data Display utility MakeClass().
//
// This class is derived from the class VViewerSelector.
// The following members functions are called by the dataDisplay Process() functions:
//    Init():        called once per dataDisplay session
//    Begin():       called everytime a loop on the data starts,
//                   a convenient place to create your histograms.
//    ProcessVect(): called for each vector(s) that should be analyzed
//    Terminate():   called at the end of a loop in the dataDisplay,
//                   a convenient place to draw/fit your histograms.
//
#include "HighPassFilter.h"

#if !defined(__CINT__) || defined(__MAKECINT__)
// Here come the user includes like
// #include "TH1F.h"
#endif

void HighPassFilter::Init()
{
}


void HighPassFilter::Begin()
{
   // Function called before starting the analysis loop.

}

Bool_t HighPassFilter::ProcessVect(int nbvect, FrVect** invects, FrVect* outvect, double* par)
{
   // Function called for selected vectors only.
   // invects is an array of vectors, nbvect is the number.
   // of vectors in the array and outvect is the resulting.
   // output vector.
   // par is a set of parameters.
   // Return kFALSE to stop processing.
   // The following code is an example, where sum of squares is computed.
   // Just replace it by your own code.

int i, j, ndata;
static double buffer0=0.;

ndata = invects[0]->nData;

for (j=0; j<ndata; j++)
   {
    if (j == 0) outvect->dataD[j] = FrVectGetV (invects[0], j) - buffer0;
    else        outvect->dataD[j] = FrVectGetV (invects[0], j) - FrVectGetV (invects[0], j-1);
   }

buffer0 = FrVectGetV (invects[0], ndata-1);

return kTRUE;

}

void HighPassFilter::Terminate()
{
   // Function called at the end of the analysis loop.


}
